package com.rightanglegames.backtothepast;

import it.randomtower.engine.ME;
import it.randomtower.engine.ResourceManager;
import it.randomtower.engine.entity.Entity;

import com.rightanglegames.backtothepast.effects.AcidBubble;

public class Acid extends Entity {

	public static final String ACID = "acid";
	
	private int frame = 0;
	private int nextFrame = ME.targetFrameRate / 6;
	
	private Entity lastVictim = null;

	public Acid(float x, float y) {
		super(x, y);
		this.depth = BackToThePast.TILES_LAYER;
		this.sheet = ResourceManager.getSpriteSheet(ACID);
		this.setHitBox(0, 2, BackToThePast.TILESIZE, BackToThePast.TILESIZE-2);
		this.setAlarm("frame", nextFrame, false, true);
		this.currentImage = this.sheet.getSprite(frame, 0);
		this.addType(Acid.ACID);
	}

	public void alarmTriggered(String name) {
		if (name.equals("frame")) {
			frame++;
			if (frame > 9) {
				frame = 0;
			}
			this.currentImage = this.sheet.getSprite(frame, 0);
		}
	}

	@Override
	public void collisionResponse(Entity other) {
		// if someone drops into acid we create some bubbles
		if (lastVictim != other) {
			lastVictim = other;
			int amount = Globals.RND.getRandomInt(10, 20);
			for (int i = 0; i < amount; i++) {
				float xpos = x + Globals.RND.getRandomInt(0, 35);
				float ypos = y + 5;
				int lifeTime = Globals.RND.getRandomInt(BackToThePast.TARGET_FRAME_RATE/2, BackToThePast.TARGET_FRAME_RATE * 2);
				this.world.add(new AcidBubble(xpos, ypos, lifeTime));
			}
		}
	}
}
