package com.rightanglegames.backtothepast;

import java.util.Hashtable;

import org.newdawn.slick.Input;

import it.randomtower.engine.World;

public class EnhancedWorld extends World {

	/** available commands for EnhancedWorld **/
	protected Hashtable<String, int[]> commands = new Hashtable<String, int[]>();

	public EnhancedWorld(int id) {
		super(id);
	}

	/**
	 * define commands to handle inputs
	 * 
	 * @param command
	 *            name of the command
	 * @param keys
	 *            keys or mouse input from {@link Input} class
	 */
	public void define(String command, int... keys) {
		commands.put(command, keys);
	}

	/**
	 * Check if a command is down
	 * 
	 * @param key
	 * @return
	 */
	public boolean check(String command) {
		int[] checked = commands.get(command);
		if (checked == null)
			return false;
		for (int i = 0; i < checked.length; i++) {
			if (this.container.getInput().isKeyDown(checked[i])) {
				return true;
			} else if (checked[i] < 10) {
				/**
				 * 10 is max number of button on a mouse
				 * 
				 * @see Input
				 */
				if (this.container.getInput().isMousePressed(checked[i])) {
					return true;
				}
			}
		}
		return false;
	}

	/**
	 * Check if a command is pressed
	 * 
	 * @param key
	 * @return
	 */
	public boolean pressed(String command) {
		int[] checked = commands.get(command);
		if (checked == null)
			return false;
		for (int i = 0; i < checked.length; i++) {
			if (this.container.getInput().isKeyPressed(checked[i])) {
				return true;
			} else if (checked[i] == Input.MOUSE_LEFT_BUTTON
					|| checked[i] == Input.MOUSE_RIGHT_BUTTON) {
				if (this.container.getInput().isMousePressed(checked[i])) {
					return true;
				}
			}
		}
		return false;
	}
}
