package com.rightanglegames.backtothepast;

import com.rightanglegames.backtothepast.weapons.Laserbeam;

import it.randomtower.engine.ResourceManager;
import it.randomtower.engine.entity.Entity;

public class Turret extends Entity {

	public static final String TURRET = "turret";
	private boolean targetingDown;
	
	public Turret(float x, float y, boolean targetingDown) {
		super(x, y);
		this.targetingDown = targetingDown;
		name = TURRET;
		depth = BackToThePast.OBJECT_LAYER;
		if (this.targetingDown) {
			sheet = ResourceManager.getSpriteSheet("turretdown");
		} else {
			sheet = ResourceManager.getSpriteSheet("turretup");
		}
		this.currentImage = sheet.getSprite(0, 0);
		addType(TURRET, SOLID);
		setHitBox(0, 0, currentImage.getWidth(), currentImage.getHeight());
		this.setAlarm("fire", BackToThePast.TARGET_FRAME_RATE * 2, true, true);
	}

	@Override
	public void alarmTriggered(String name) {
		if (name.equals("fire")) {
			this.currentImage = sheet.getSprite(1, 0);
			this.fireLaserbeam(BackToThePast.TARGET_FRAME_RATE * 2);
			this.setAlarm("fireoff", BackToThePast.TARGET_FRAME_RATE * 2, true, true);
		} else if (name.equals("fireoff")) {
			this.currentImage = sheet.getSprite(0, 0);
			this.setAlarm("fire", BackToThePast.TARGET_FRAME_RATE * 2, true, true);
		}
		
	}
	
	private void fireLaserbeam(int duration) {
		int yincr, laserX, laserY;
		
		if (this.targetingDown)
			yincr = 1;
		else
			yincr = -1;
		Level level = ((IngameState) world).getCurrentLevel();
		laserX = (int)this.x / BackToThePast.TILESIZE;
		laserY = (int)this.y / BackToThePast.TILESIZE;
		boolean blocked = false;
		laserY += yincr;
		while (!blocked) {
			if (!level.blocked(null, laserX, laserY)) {
				// create a laser beam here
				world.add(new Laserbeam(laserX*BackToThePast.TILESIZE, laserY*BackToThePast.TILESIZE, 1000, null, duration));
				laserY += yincr;
			} else
				blocked = true;
		}
	}

}
