package com.rightanglegames.backtothepast.weapons;

import it.randomtower.engine.ResourceManager;
import it.randomtower.engine.entity.Entity;

import org.newdawn.slick.GameContainer;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.geom.Vector2f;

import com.rightanglegames.backtothepast.Crate;
import com.rightanglegames.backtothepast.effects.DebrisExplosion;
import com.rightanglegames.backtothepast.effects.Explosion;
import com.rightanglegames.backtothepast.enemies.Enemy;

public class Laserbeam extends Weapon {

	public static String LASERBEAM = "laserbeam";
	
	public Laserbeam(float x, float y, int damage, Vector2f speed, float life) {
		super(x, y, damage, speed, life);
		this.setHitBox(16, 0, 8, 40);
		this.addType(LASERBEAM);
		this.sheet = ResourceManager.getSpriteSheet(LASERBEAM);
		this.currentImage = sheet.getSprite(0, 0);
	}

	@Override
	public void update(GameContainer container, int delta) throws SlickException {
		float explx;
		
		super.update(container, delta);
		// collision with player - deal damage
		Entity mage = collide(Entity.PLAYER, x, y);
		if (mage != null) {
			// player dies
			this.world.add(new Explosion(this.x-24, this.y-24,60));
			return;
		}
		// collision with crates - destroy crate in an explosion
		Entity crate = collide(Crate.CRATE, x, y);
		if (crate != null) {
			this.world.add(new DebrisExplosion(this.x-24, this.y-24,60));
			return;
		}
	}
}
