package com.rightanglegames.backtothepast.weapons;

import it.randomtower.engine.entity.Entity;

import org.newdawn.slick.GameContainer;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.geom.Vector2f;

import com.rightanglegames.backtothepast.BackToThePast;

public abstract class Weapon extends Entity {

	public static final String WEAPON = "weapon";
	protected int damage;
	protected float life;
	
	public Weapon(float x, float y, int damage, Vector2f speed, float life) {
		super(x, y);
		this.damage = damage;
		this.speed = speed;
		this.life = life;
		this.depth = BackToThePast.EFFECTS_LAYER;
		this.addType(WEAPON);
	}

	@Override
	public void update(GameContainer container, int delta) throws SlickException {
		super.update(container, delta);
		life --;
		if (life <= 0)
			this.destroy();
	}
	
	
	public int getDamage() {
		return damage;
	}

	public void setDamage(int damage) {
		this.damage = damage;
	}

}
